import React from 'react';
import { Layout, message } from 'antd';

import MenuView from '../view/MenuView';
import Fetch from '../fetch';
import subData from '../data/menu';
const { Sider } = Layout;
function find(data, pathname) {
  for (const { path, children } of data) {
    if (path === pathname) return path;
    if (children) {
      const result = find(children, pathname);
      if (result) return result;
    }
  }
  return null;
}

function selected(data, pathname) {
  if (!pathname || pathname === '/') return pathname;
  return find(data, pathname) || selected(data, pathname.split('/').slice(0, -1).join('/'));
}

export default class Menu extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      collapsed: false,
      data: subData([{
        name: 'backIndex',
        count: 0
      }, {
        name: 'allMsg',
        count: 0
      }])
    }
  }

  componentDidMount() {
    Fetch.getMenu()
      .then(data => {
        if (data.code === 0) {
          this.setState({ data: subData(data.data) });
        }
      })
  }
  onCollapse = collapsed => {
    this.setState({ collapsed });
  }
  render() {
    const { data } = this.state;
    const pathname = selected(data, this.props.location.pathname);
    return (
      <Sider onCollapse={this.onCollapse}
        collapsed={this.state.collapsed}
        className="sider-light"
        breakpoint="lg"
        width='260px'
      >
        <MenuView data={data}
          defaultOpenKeys={[(data.find(node => node.children && node.children.find(child => child.path == pathname)) || {}).name]}
          defaultSelectedKeys={[pathname]}
          style={{
            display: 'flex',
            flexDirection: 'column'
          }}
        />
      </Sider>
    )
  }
}


